routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::group(['middleware' => 'auth'],function (){
    Route::get('/', function () {
        return view('dashboard.index');
    });

    Route::get('/dashboard','DashboardController@index')->name('dashboard');
    Route::resource('post','PostController');
    Route::resource('message','MessageController');
    Route::resource('comment','CommentController');


});

Auth::routes();

Route::get('/cl',function (){
    Artisan::call('view:clear');
    Artisan::call('route:clear');
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return 'cache cleared';
});

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $table = 'posts';
    protected $fillable = ['user_id','post_title','post_body','post_file','status','published_at'];


    public function user(){
        return $this->belongsTo(User::class);
    }

    public function comment(){
        return $this->hasMany(Comment::class);
    }






}

app/Http/Controllers/DashboardController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class DashboardController extends Controller
{


    public function index(){

        $posts = Post::with(['user','comment'])->get();
//        return $posts;die();

        Log::info($posts);
        return view('dashboard.index',compact('posts'));
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use App\Http\Requests\PostStoreRequest;
use Illuminate\Http\Request;
use App\User;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Log;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $posts = Post::with('user')->where('user_id', Auth::user()->id)->get();

        return view('dashboard.post.index',compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('dashboard.post.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PostStoreRequest $request)
    {
        Log::info($request);
       $user = Post::create([
           'user_id' => Auth::user()->id,
           'post_title' => $request->input('post_title'),
           'post_body' => $request->input('post_body'),
           'post_file' => (!is_null($request->file('post_file'))) ? $request->file('post_file')->getClientOriginalName(): '',
           'status' => 'active',
           'published_at' => date('Y-m-d H:i:s')
       ]);

        if(!is_null($request->post_file)){
            $request->post_file->move(public_path('images'), $request->file('post_file')->getClientOriginalName());
        }

//       $this->handleUploadImage($request->file('post_file'));

        return redirect()->back();


    }

    public function handleUploadImage($post_file){
        if(!is_null($post_file)){
            $post_file->move(public_path('/images').'temp');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $post = Post::findOrFail($id);

       return  view('dashboard.post.edit',compact('post'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(PostStoreRequest $request, $id)
    {

        $post = Post::find($id);

        $post->post_title = $request->post_title;
        $post->post_body = $request->post_body;
        $post->post_file = $request->post_file;

        $post->save();

       return redirect()->route('post.index');




    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {
        $post = Post::findOrFail($post);


    }



}

resources/views/dashboard/post/create.blade.php
@extends('layouts.backend')

@section('content')

    <h3>Create New</h3>

    <form method="post" action="{{route('post.store')}}" enctype="multipart/form-data">
        @csrf

        <div class="form-group row">
            <label for="">post title </label>
            <input type="text" name="post_title" value="{{old('post_title')}}">

            @error('post_title')
            <span class="text-danger"> {{$message}}</span>
            @enderror
        </div>

        <div class="form-group row">
            <label for="">conent</label>
            <textarea cols="40" rows="10" type="text" name="post_body">
                {{old('post_title')}}
            </textarea>
            @error('post_body')
            <span class="text-danger"> {{$message}}</span>
            @enderror
        </div>
        <div class="form-group row">
            <label for="">Attachment</label>
            <input type="file" name="post_file">
        </div>


        <div>
            <button type="submit">Submit</button>
        </div>

    </form>


@endsection

resources/views/dashboard/post/edit.blade.php
@extends('layouts.backend')

@section('content')



    <h3>Create New</h3>

    <form method="POST" action="{{route('post.update',$post->id)}}" enctype="multipart/form-data">
        @csrf
        @method('PUT')

        <div class="form-group row">
            <label for="">post title </label>
            <input type="text" name="post_title" value="{{$post->post_title}}">
        </div>
        <div class="form-group row">
            <label for="">conent</label>
            <textarea rows="10" type="text" name="post_body">
                {{$post->post_body}}
            </textarea>
        </div>
        <div class="form-group row">
            <label for="">Attachment</label>


            <input type="file" name="post_file">
        </div>


        <div>
            <button type="submit">Submit</button>
        </div>

    </form>



@endsection

resources/views/dashboard/post/index.blade.php
@extends('layouts.backend')

@section('content')

    <div class="row">
        <div class="col-12">
            <h4>List of : Posts</h4>
            <a href="{{route('post.create')}}" class="btn btn-info float-right"> Add New</a>
        </div>
        <div class="col-12">
            <table class="table-striped table">

                    <tr>
                        <th>Post Title</th>
                        <th>Content</th>
                        <th>Attachment</th>
                        <th>Status</th>
                        <th>Author</th>
                        <th>Created</th>
                        <th>Actions</th>
                    </tr>



                @if(isset($posts) && count($posts)>0)
                    @foreach($posts as $post)
                    <tr>
                        <td>{{$post->post_title}}</td>
                        <td> {{Str::limit($post->post_body,200)}}</td>
                        <td>{{$post->post_file}}</td>
                        <td>{{$post->status}}</td>
                        <td>{{$post->user->name}}</td>
                        <td>{{$post->created_at}}</td>
                        <td>
                            <a href="{{route('post.edit',$post->id)}}" class="link">Edit</a>
                            <a href="" class="link">Del</a>
                        </td>
                    </tr>
                    @endforeach
                    @else
                    <tr>
                        <td colspan="7"> No record found.</td>
                    </tr>

                @endif

            </table>
        </div>
    </div>




@endsection